clear
close all
clc

tic
addpath C:\USERS\conolo\RBData\Matlab\Type_Errors\

DIM   =   60;   %  TRANSITION LENGTH
Year   =   2020:+10:2020+(DIM-1)*10;

% % %  -------------------------- USE COAL TAXES --------------------------
% % %  -------------------------- USE COAL TAXES --------------------------
% % %  -------------------------- USE COAL TAXES --------------------------

% % % ----------------- SET REGIME AND ELASTICITY -------------------------
TAX_DUM   =   1;
Tax_dum   =   2;
% % % CO2 TAXES IN ALL COUNTRIES: Tax_dum   =   1;
% % % COAL TAXES IN ALL COUNTRIES: Tax_dum   =   2;

% % % ----------------- FOSSIL SUBSIDY IN CHINA -------------------------
s_china  =   0.083;

if s_china>0
    disp('CHINA SUBSIDIES COAL')
end

% % % --------------------- TYPE 1 AND 2 ERRORS ---------------------------
% % % --------------------- TYPE 1 AND 2 ERRORS ---------------------------
% % % --------------------- TYPE 1 AND 2 ERRORS ---------------------------
% % % TYPE 1 AND 2 ERRORS ARE COMPUTED FOR BOTH THE BENCHMARK ELASTICITY OF
% 0.95 AND FOR A HIGHER ELASTICITY. FIRST SOLVE THE MODEL FOR THE BENCHMARK
% VALUE. THEN RUN THE EXPERIMENT AGAIN WITH THE HIGHER ELASTICITY


% % % --------------------------- PARAMETERS ------------------------------
BM_elast   =   0.95;   % Bennchmark elasticity of substitution between green and brown
elast   =   BM_elast;   % Elasticity of substitution between green and brown

elast   =   1.25;   % Elasticity of substitution between green and brown
rho     =   (elast-1)/elast;

alpha   =   0.3;        % Capital share
beta    =   0.985^10;   % Discount factor
nu      =   0.031;      % Energy share

% -------------------------- FOR THE OIL COMPOSITE ------------------------
elast_h   =  10;
rho_h     =   (elast_h-1)/elast_h;
Oil_weight   =   0.44;

% --------------- OIL EXTRACTION THAT DIRECTLY GENERATE EMISSIONS ---------
Supply_emiss   =  0.32;

% % % ----------------------- CLIMATE PARAMETERS --------------------------
% % % ----------------------- CLIMATE PARAMETERS --------------------------
% % % ----------------------- CLIMATE PARAMETERS --------------------------

lambda_1   =   0.54289;
lambda_2   =   0.187*lambda_1;
lambda_3   =   0.655*lambda_1;

S_preind   =   581; % MEASURED IN GtC
S0         =   800;
T_0        =   0.85;
TL_0       =   0.01;

% % % ---------------------------- DAMAGES --------------------------------
% % % ---------------------------- DAMAGES --------------------------------
% % % ---------------------------- DAMAGES --------------------------------

eta   =   3.7;
lambda   =   3;
Sigma1   =   0.22;
Sigma2   =   0.3;
Sigma3   =   0.05;

% % % ------- BENCHMARK -------
psi    =   0.0228; % 0.0228
psiL   =   0.2;    % 0.2
psi0   =   0.393;  % 0.393
% % % BENCHMARK: psi = 0.0228; psiL = 0.2; psi0 = 0.393;


% % % ----------------------- INTITAL CONDITIONS --------------------------
% % % ----------------------- INTITAL CONDITIONS --------------------------
% % % ----------------------- INTITAL CONDITIONS --------------------------

% % ---------------------------- CAPITAL --------------------------------
K_0_EU = 39.2*.983;K_0_US = 39.2*.99;K_0_CH = 39.2*1.0;K_0_AF = 19.6*.63;
K_0_IND = 19.6*1.025;K_0_SA = 19.6*.635;K_0_OC = 19.6*1.49;

% % ---------------------------- TFP --------------------------------
% % ---------------- SET Glob_TFP TO MATCH WORLD GDP
Glob_TFP           =   .95;
Initial_prod_EU = Glob_TFP*55.5;Initial_prod_US = Glob_TFP*55.5;
Initial_prod_CH = Glob_TFP*55.5;Initial_prod_AF = Glob_TFP*25.9;
Initial_prod_IND = Glob_TFP*35.9;Initial_prod_SA  = Glob_TFP*25.9;
Initial_prod_OC  = Glob_TFP*45.9;

% % % --------------- PRODUCTIVITY GROWTH AND CATCH-UP ------------------
Convergence_prod_fact   =   1.6;
Prod_growth             =   1.015^10;

% % --------------------------- PRICES ----------------------------------
% % % % ------  USE GREEN PRICES TO CALIBRATE THE MODEL -----------------
Green_price_Init     = 600;
Green_price_Init_EU  = Green_price_Init; Green_price_Init_US = Green_price_Init;
Green_price_Init_CH  = Green_price_Init;Green_price_Init_AF  = Green_price_Init;
Green_price_Init_IND = Green_price_Init;Green_price_Init_SA  = Green_price_Init;
Green_price_Init_OC  = Green_price_Init;

% % -------------------- CARBON CONTENT ---------------------------------
Carbon_content_oil    =   84.6/100;
Carbon_content_coal   =   71.6/100;

C_price                     =   74;
Coal_price_global_p_ton_C =   C_price/Carbon_content_coal;
Coal_price_Init_EU =   C_price/Carbon_content_coal;
Coal_price_Init_US =   C_price/Carbon_content_coal;
Coal_price_Init_CH =   C_price/Carbon_content_coal;
Coal_price_Init_AF =   C_price/Carbon_content_coal;
Coal_price_Init_IND =  C_price/Carbon_content_coal;
Coal_price_Init_SA  =  C_price/Carbon_content_coal;
Coal_price_Init_OC  =  C_price/Carbon_content_coal;


Growth_factor_oil_subst    =  1;
% % -------------------------- FRACKING ---------------------------------
% % FROM THE EIA: The U.S. Energy Information Administration (EIA) estimates that in 2018,
% % about 6.5 million barrels per day of crude oil were produced directly from
% % tight oil resources in the United States. This was equal to about 59 percent
% % of total U.S. crude oil production in 2018.

Oil_subst_price_Init_US     =   347;

CONS_EU = ones(4,DIM);CONS_US = CONS_EU;CONS_CH = CONS_EU;
CONS_AF = CONS_EU;CONS_IND = CONS_EU;CONS_SA = CONS_EU;CONS_OC = CONS_EU;

OIL_EU = ones(4,DIM);OIL_US = OIL_EU;OIL_CH = OIL_EU;
OIL_AF = OIL_EU;OIL_IND = OIL_EU;OIL_SA = OIL_EU;
OIL_OC = OIL_EU;

COAL_EU = ones(4,DIM);COAL_US = COAL_EU;COAL_CH = COAL_EU;
COAL_AF = COAL_EU;COAL_IND = COAL_EU;COAL_SA  = COAL_EU;
COAL_OC = COAL_EU;

GREEN_EU = ones(4,DIM);GREEN_US = GREEN_EU;GREEN_CH = GREEN_EU;
GREEN_AF = GREEN_EU;GREEN_IND = GREEN_EU;GREEN_SA =  GREEN_EU;
GREEN_OC = GREEN_EU;

ENERGY_COMP_EU = ones(4,DIM);ENERGY_COMP_US = ones(4,DIM);
ENERGY_COMP_CH = ones(4,DIM);ENERGY_COMP_AF = ones(4,DIM);
ENERGY_COMP_IND = ones(4,DIM);ENERGY_COMP_SA = ones(4,DIM);
ENERGY_COMP_OC = ones(4,DIM);


% % % -------------------------- AGGREGATES -------------------------------
% % % -------------------------- AGGREGATES -------------------------------
% % % -------------------------- AGGREGATES -------------------------------
S               =   S0*ones(DIM,1);
S2              =   ones(DIM,1);
S1_S_Bar        =   ones(DIM,1);
Temp            =   T_0*ones(DIM,1);
Temp_L          =   TL_0*ones(DIM,1);
Forcing         =   ones(DIM,1);
Global_Damage   =   ones(DIM,1);

Oil_Use_Agg           =   ones(DIM,1);
Coal_Use_Agg          =   ones(DIM,1);
Green_Use_Agg         =   ones(DIM,1);
Emissions_Oil_Count   =   ones(DIM,1);
Emissions_Agg         =   ones(DIM,1);

GROSS_OUT_Yearly_Agg        =   ones(DIM,1);
GDP_Yearly_Agg              =   ones(DIM,1);

% % % ---------------- VARY THE WRONG TAX OF UNDERESTIMATING CC -----------
% % % -------------------- NOTE THAT TAXES ARE PROPORTIONAL ---------------
% % % -UPPER GAMMA IS 3.44 AND THE CORRESPONDING CORRECT TAX IS 0.768*3.44-
GAMMA   =   [0.0894;3.44];

% % % ----------------------- INTITAL CONDITIONS --------------------------
% % % ----------------------- INTITAL CONDITIONS --------------------------
% % % ----------------------- INTITAL CONDITIONS --------------------------


for gamma_dum=1:length(GAMMA)
    
    t_loop = 2;
    
    for taxes=1:t_loop
        % % % ------------- LOOP OVER CORRECT AND INCORRECT TAX RATES -------------
        % % % ------------- LOOP OVER CORRECT AND INCORRECT TAX RATES -------------
        % % % ------------- LOOP OVER CORRECT AND INCORRECT TAX RATES -------------
        
        IND   =  taxes + 2*(gamma_dum-1);
        
        % % % IND   =  1: LOW TAX WHEN LOW TAX IS CORRECT
        % % % IND   =  2: HIGH TAX WHEN LOW TAX IS CORRECT
        % % % IND   =  3: LOW TAX WHEN HIGH TAX IS CORRECT
        % % % IND   =  4: HIGH TAX WHEN HIGH TAX IS CORRECT
        
        
        % % % -------------------------- TAX RATE -------------------------
        % % % -------------------------- TAX RATE -------------------------
        % % % -------------------------- TAX RATE -------------------------
        
        Tax_carbon   =   0.0768*GAMMA(taxes);

        Growth_tax_rate   =   1.022^10;
  
        [Tax_rate_Coal_US,Tax_rate_Oil_US,Tax_rate_Coal_EU,Tax_rate_Oil_EU,...
            Tax_rate_Coal_CH,Tax_rate_Oil_CH,Tax_rate_Coal_SA,Tax_rate_Oil_SA,...
            Tax_rate_Coal_DEV,Tax_rate_Oil_DEV,Tax_rate_Coal_OC,Tax_rate_Oil_OC,...
            Tax_rate_Frack_US,Tax_rate_Frack_CH] =  Tax_regimes(Tax_dum);
        
        
        gamma_global   =   (3.21e-5)*GAMMA(gamma_dum);
        gamma_EU       =   (2.698087632e-5)*GAMMA(gamma_dum);
        gamma_US       =   (2.395371224e-5)*GAMMA(gamma_dum);
        gamma_CH       =   (2.513277301e-5)*GAMMA(gamma_dum);
        gamma_AF       =   (5.058200664e-5)*GAMMA(gamma_dum);
        gamma_IND      =   (5.03073519e-5)*GAMMA(gamma_dum);
        gamma_SA       =   (2.57542713e-5)*GAMMA(gamma_dum);
        gamma_OC       =   (2.742877657e-5)*GAMMA(gamma_dum);

        Capgamma   =   gamma_global*(psiL/(1-beta)+(1-psiL)*psi0/(1-(1-psi)*beta));
        xi         =   1;
        
        R0         =   330*Carbon_content_oil; 

        
        % % %   THE SAVINGS RATE OF NET OUTPUT
        
        saving_rate   =   alpha*beta/(1-nu);
        
        
        % % % % % % -------------------- GUESS ON THE OIL PRICE -----------------
        % % % % % % -------------------- GUESS ON THE OIL PRICE -----------------
        % % % % % % -------------------- GUESS ON THE OIL PRICE -----------------
        
        Oil_Price   =  ones(DIM,1);
        
        % % % ----------- FIND THE OIL PRICE FOR EACH t WITH BISECTION ------------
        Oil_Price_min_1   =   ones(DIM,1);
        Oil_Price_max_1   =   ones(DIM,1);
        
        Oil_Price_min   =   0;
        Oil_Price_max   =   1;
        
        % % % --------------- CHECK SO THAT THE SOLUTION IS INTERIOR --------------
        Oil_Price_min_1(1)   =   Oil_Price_min;
        Oil_Price_max_1(1)   =   Oil_Price_max;
        
        Oil_Price(1)   =   (Oil_Price_min + Oil_Price_max)/2;
        
        Oil_Reserves   =   R0*ones(DIM,1);
        Oil_Supply   =     ones(DIM,1);
        for i   =   1:DIM
            Oil_Supply(i,1)   =   (1-beta)*Oil_Reserves(i);
            Oil_Reserves(i+1,1)   =   Oil_Reserves(i)-Oil_Supply(i,1);
        end
        
        Productivity_EU    =   (Initial_prod_EU*Prod_growth.^(0:DIM-1))';
        Productivity_US    =   (Initial_prod_US*Prod_growth.^(0:DIM-1))';
        
        % % % --------- CONVERGENCE FOR THE OTHER REGIONS ---------
        Conv_prod_CH    =   (Convergence_prod_fact*Initial_prod_CH)*(Prod_growth.^(0:DIM-1)');
        Conv_prod_AF    =   (Convergence_prod_fact*Initial_prod_AF)*(Prod_growth.^(0:DIM-1)');
        Conv_prod_IND   =   (Convergence_prod_fact*Initial_prod_IND)*(Prod_growth.^(0:DIM-1)');
        Conv_prod_SA    =   (Convergence_prod_fact*Initial_prod_SA)*(Prod_growth.^(0:DIM-1)');
        Conv_prod_OC    =   (Convergence_prod_fact*Initial_prod_OC)*(Prod_growth.^(0:DIM-1)');

        
        Productivity_CH   =   Initial_prod_CH*ones(DIM,1);
        Productivity_AF   =   Initial_prod_AF*ones(DIM,1);
        Productivity_IND  =   Initial_prod_IND*ones(DIM,1);
        Productivity_SA   =   Initial_prod_SA*ones(DIM,1);
        Productivity_OC   =   Initial_prod_OC*ones(DIM,1);
        
        for t=2:DIM
            Productivity_CH(t)    =   (Prod_growth)*Productivity_CH(t-1)*(Conv_prod_CH(t-1)/Productivity_CH(t-1))^0.25;
            Productivity_AF(t)    =   (Prod_growth)*Productivity_AF(t-1)*(Conv_prod_AF(t-1)/Productivity_AF(t-1))^0.25;
            Productivity_IND(t)   =   (Prod_growth)*Productivity_IND(t-1)*(Conv_prod_IND(t-1)/Productivity_IND(t-1))^0.25;
            Productivity_SA(t)    =   (Prod_growth)*Productivity_SA(t-1)*(Conv_prod_SA(t-1)/Productivity_SA(t-1))^0.25;
            Productivity_OC(t)    =   (Prod_growth)*Productivity_OC(t-1)*(Conv_prod_OC(t-1)/Productivity_OC(t-1))^0.25;
        end
        
        % % % ----------------- PREDEFINE VARIABLES -------------------
        % % % ----------------- PREDEFINE VARIABLES -------------------
        % % % ----------------- PREDEFINE VARIABLES -------------------
        Damage_EU               =   ones(DIM,1);
        Capital_EU              =   K_0_EU*ones(DIM,1);
        Capital_US              =   K_0_US*ones(DIM,1);
        Capital_CH              =   K_0_CH*ones(DIM,1);
        Capital_AF              =   K_0_AF*ones(DIM,1);
        Capital_IND             =   K_0_IND*ones(DIM,1);
        Capital_SA              =   K_0_SA*ones(DIM,1);
        Capital_OC              =   K_0_OC*ones(DIM,1);
        
        MPK_EU              =   K_0_EU*ones(DIM,1);
        MPK_US              =   K_0_EU*ones(DIM,1);
        MPK_CH              =   K_0_EU*ones(DIM,1);
        MPK_AF              =   K_0_EU*ones(DIM,1);
        MPK_IND             =   K_0_EU*ones(DIM,1);
        MPK_SA              =   K_0_EU*ones(DIM,1);
        MPK_OC              =   K_0_EU*ones(DIM,1);
        
        Cons_Oil_Producers      =   ones(DIM,1);
        
        Tax_Oil_EU              =   ones(DIM,1);
        Coal_Price_EU           =   ones(DIM,1);
        Tax_Coal_EU             =   ones(DIM,1);
        Green_Price_EU          =   ones(DIM,1);
        Tax_Green_EU            =   ones(DIM,1);
        Energy_Price_EU         =   ones(DIM,1);
        Energy_Services_EU      =   ones(DIM,1);
        Oil_Use_EU              =   ones(DIM,1);
        Coal_Use_EU             =   ones(DIM,1);
        Green_Use_EU            =   ones(DIM,1);
        Gross_Output_EU         =   ones(DIM,1);
        GDP_EU                  =   ones(DIM,1);
        
        % % % ----------- FRACKING --------------
        Oil_subst_Use_US        =   ones(DIM,1);        
        Oil_subst_Price_US      =   ones(DIM,1);
        
        Oil_comp_Price_US       =   ones(DIM,1);
        Oil_comp_Use_US         =   ones(DIM,1);
               
        Tax_Oil_subst_US        =   ones(DIM,1);
        
        Fracking_Agg                =   ones(DIM,1);
        
        Net_Output_Inc_tax_EU    =   ones(DIM,1);
        Net_Output_Inc_tax_US    =   ones(DIM,1);
        Net_Output_Inc_tax_CH    =   ones(DIM,1);
        Net_Output_Inc_tax_AF    =   ones(DIM,1);
        Net_Output_Inc_tax_IND   =   ones(DIM,1);
        Net_Output_Inc_tax_SA    =   ones(DIM,1);
        Net_Output_Inc_tax_OC    =   ones(DIM,1);
        
        Consuption_Yearly_EU    =   ones(DIM,1);
        
        Damage_US=Damage_EU; Damage_CH=Damage_EU; Damage_AF=Damage_EU; ...
            Damage_IND=Damage_EU; Damage_SA=Damage_EU; Damage_OC=Damage_EU;
        
        Tax_Oil_US=Tax_Oil_EU;Tax_Oil_CH=Tax_Oil_EU;Tax_Oil_AF=Tax_Oil_EU;...
            Tax_Oil_IND=Tax_Oil_EU;Tax_Oil_SA=Tax_Oil_EU;Tax_Oil_OC=Tax_Oil_EU;
        
        Coal_Price_US=Coal_Price_EU;Coal_Price_CH=Coal_Price_EU;
        Coal_Price_AF=Coal_Price_EU;Coal_Price_IND=Coal_Price_EU;
        Coal_Price_SA=Coal_Price_EU;Coal_Price_OC=Coal_Price_EU;
        
        Tax_Coal_US=Tax_Coal_EU;Tax_Coal_CH=Tax_Coal_EU;
        Tax_Coal_AF=Tax_Coal_EU;Tax_Coal_IND=Tax_Coal_EU;
        Tax_Coal_SA=Tax_Coal_EU;Tax_Coal_OC=Tax_Coal_EU;
        
        Green_Price_US=Green_Price_EU;Green_Price_CH=Green_Price_EU;
        Green_Price_AF=Green_Price_EU;Green_Price_IND=Green_Price_EU;
        Green_Price_SA=Green_Price_EU;Green_Price_OC=Green_Price_EU;
        
        Tax_Green_US=Tax_Green_EU;Tax_Green_CH=Tax_Green_EU;
        Tax_Green_AF=Tax_Green_EU;Tax_Green_IND=Tax_Green_EU;
        Tax_Green_SA=Tax_Green_EU;Tax_Green_OC=Tax_Green_EU;
        
        Energy_Price_US=Energy_Price_EU;Energy_Price_CH=Energy_Price_EU;
        Energy_Price_AF=Energy_Price_EU;Energy_Price_IND=Energy_Price_EU;
        Energy_Price_SA=Energy_Price_EU;Energy_Price_OC=Energy_Price_EU;
        Energy_Services_US=Energy_Services_EU;Energy_Services_CH=Energy_Services_EU;
        Energy_Services_AF=Energy_Services_EU;Energy_Services_IND=Energy_Services_EU;
        Energy_Services_SA=Energy_Services_EU;Energy_Services_OC=Energy_Services_EU;
        
        Oil_Use_US=Oil_Use_EU;Oil_Use_CH=Oil_Use_EU;
        Oil_Use_AF=Oil_Use_EU;Oil_Use_IND=Oil_Use_EU;
        Oil_Use_SA=Oil_Use_EU;Oil_Use_OC=Oil_Use_EU;
        
        Coal_Use_US=Coal_Use_EU;Coal_Use_CH=Coal_Use_EU;
        Coal_Use_AF=Coal_Use_EU;Coal_Use_IND=Coal_Use_EU;
        Coal_Use_SA=Coal_Use_EU;Coal_Use_OC=Coal_Use_EU;
        
        Green_Use_US=Green_Use_EU;Green_Use_CH=Green_Use_EU;
        Green_Use_AF=Green_Use_EU;Green_Use_IND=Green_Use_EU;
        Green_Use_SA=Green_Use_EU;Green_Use_OC=Green_Use_EU;
        
        Gross_Output_US=Gross_Output_EU;Gross_Output_CH=Gross_Output_EU;
        Gross_Output_AF=Gross_Output_EU;Gross_Output_IND=Gross_Output_EU;
        Gross_Output_SA=Gross_Output_EU;Gross_Output_OC=Gross_Output_EU;
        
        GDP_US=GDP_EU;GDP_CH=GDP_EU;GDP_AF=GDP_EU;GDP_IND=GDP_EU;...
            GDP_SA=GDP_EU;GDP_OC=GDP_EU;
        
        Consuption_Yearly_US=Consuption_Yearly_EU;Consuption_Yearly_CH=Consuption_Yearly_EU;
        Consuption_Yearly_AF=Consuption_Yearly_EU;Consuption_Yearly_IND=Consuption_Yearly_EU;
        Consuption_Yearly_SA=Consuption_Yearly_EU;Consuption_Yearly_OC=Consuption_Yearly_EU;
        
        Coal_Price_EU(1)       =   Coal_price_Init_EU/1000;
        Coal_Price_US(1)       =   Coal_price_Init_US/1000;
        Coal_Price_CH(1)       =   Coal_price_Init_CH/1000;
        Coal_Price_AF(1)       =   Coal_price_Init_AF/1000;
        Coal_Price_IND(1)      =   Coal_price_Init_IND/1000;
        Coal_Price_SA(1)       =   Coal_price_Init_SA/1000;
        Coal_Price_OC(1)       =   Coal_price_Init_OC/1000;
        
        Green_Price_EU(1)       =   Green_price_Init_EU/1000;
        Green_Price_US(1)       =   Green_price_Init_US/1000;
        Green_Price_CH(1)       =   Green_price_Init_CH/1000;
        Green_Price_AF(1)       =   Green_price_Init_AF/1000;
        Green_Price_IND(1)      =   Green_price_Init_IND/1000;
        Green_Price_SA(1)       =   Green_price_Init_SA/1000;
        Green_Price_OC(1)       =   Green_price_Init_OC/1000;
        
        Oil_subst_Price_US(1)   =   Oil_subst_price_Init_US/1000;
        
        for t=1:DIM
            
            % % % ---------------------- ITERATE OVER THE OIL PRICE -------------------
            diff_oil_p   =   10;
            Oil_Price_old   =   Oil_Price(t);
            while diff_oil_p>1e-8
                
                % % % ---------------------------- EUROPE ---------------------------------
                % % % ---------------------------- EUROPE ---------------------------------
                % % % ---------------------------- EUROPE ---------------------------------
                Damage_EU(t)           =   1 - exp(-gamma_EU*(S(t)-S_preind));
                Tax_Oil_EU(t)          =   Tax_carbon*Tax_rate_Oil_EU*(Growth_tax_rate^(t-1));
                Coal_Price_EU(t+1)     =   Coal_Price_EU(t);
                Tax_Coal_EU(t)         =   Tax_carbon*Tax_rate_Coal_EU*(Growth_tax_rate^(t-1));
                Green_Price_EU(t+1)    =   Green_Price_EU(t);
                Tax_Green_EU(t)        =   0;
                Energy_Price_EU(t)     =   ((Oil_Price(t)+Tax_Oil_EU(t))^(rho/(rho-1))*lambda_1^(1/(1-rho)) +(Coal_Price_EU(t)+Tax_Coal_EU(t))^(rho/(rho-1))*lambda_2^(1/(1-rho))+...
                    (Green_Price_EU(t)+Tax_Green_EU(t))^(rho/(rho-1))*lambda_3^(1/(1-rho)))^((rho-1)/rho);
                
                Energy_Services_EU(t)  =   (nu*Productivity_EU(t)*(1-Damage_EU(t))*Capital_EU(t)^alpha/Energy_Price_EU(t))^(1/(1-nu));
                
                Oil_Use_EU(t)          =   Energy_Services_EU(t)*(Energy_Price_EU(t)*lambda_1/(Oil_Price(t)+Tax_Oil_EU(t)))^(1/(1-rho));
                Coal_Use_EU(t)         =   Energy_Services_EU(t)*(Energy_Price_EU(t)*lambda_2/(Coal_Price_EU(t)+Tax_Coal_EU(t)))^(1/(1-rho));
                Green_Use_EU(t)        =   Energy_Services_EU(t)*(Energy_Price_EU(t)*lambda_3/(Green_Price_EU(t)+Tax_Green_EU(t)))^(1/(1-rho));
                
                Gross_Output_EU(t)           =   Productivity_EU(t)*(1-Damage_EU(t))*(Capital_EU(t)^alpha)*(Energy_Services_EU(t)^nu);
                GDP_EU(t)                    =   Gross_Output_EU(t)-Oil_Price(t)*Oil_Use_EU(t);
                Net_Output_Inc_tax_EU(t)     =   (1-nu)*Gross_Output_EU(t)+Tax_Oil_EU(t)*Oil_Use_EU(t)+Tax_Coal_EU(t)*Coal_Use_EU(t)+Tax_Green_EU(t)*Green_Use_EU(t);
                Capital_EU(t+1)              =   saving_rate*Net_Output_Inc_tax_EU(t);
                MPK_EU(t)                    =   alpha*Gross_Output_EU(t)/Capital_EU(t);
                Consuption_Yearly_EU(t)      =   Net_Output_Inc_tax_EU(t)*(1-alpha*beta)/10;
                
                % % % ------------------------------ US -----------------------------------
                % % % ------------------------------ US -----------------------------------
                % % % ------------------------------ US -----------------------------------
                Damage_US(t)              =   1 - exp(-gamma_US*(S(t)-S_preind));
                Tax_Oil_US(t)             =   Tax_carbon*Tax_rate_Oil_US*(Growth_tax_rate^(t-1));
                Coal_Price_US(t+1)        =   Coal_Price_US(t);
                Tax_Coal_US(t)            =   Tax_carbon*Tax_rate_Coal_US*(Growth_tax_rate^(t-1));
                Green_Price_US(t+1)       =   Green_Price_US(t);
                Tax_Green_US(t)           =   0;
                Oil_subst_Price_US(t+1)   =   Oil_subst_Price_US(t);
                
                Tax_Oil_subst_US(t)     =   Tax_carbon*Tax_rate_Frack_US*(Growth_tax_rate^(t-1));
                
                Oil_comp_Price_US(t) = (1/2)*(Oil_weight^(1/(1-rho_h))*(Oil_Price(t)+Tax_Oil_US(t))^(rho_h/(rho_h-1))+(1-Oil_weight)^(1/(1-rho_h))*(Oil_subst_Price_US(t)+Tax_Oil_subst_US(t))^(rho_h/(rho_h-1)))^((rho_h-1)/rho_h);
                
                
                Energy_Price_US(t)     =   ((Oil_comp_Price_US(t))^(rho/(rho-1))*lambda_1^(1/(1-rho)) +(Coal_Price_US(t)+Tax_Coal_US(t))^(rho/(rho-1))*lambda_2^(1/(1-rho))+...
                    (Green_Price_US(t)+Tax_Green_US(t))^(rho/(rho-1))*lambda_3^(1/(1-rho)))^((rho-1)/rho);
                
                Energy_Services_US(t)  =   (nu*Productivity_US(t)*(1-Damage_US(t))*(Capital_US(t)^alpha)/Energy_Price_US(t))^(1/(1-nu));
                
                Coal_Use_US(t)         =   Energy_Services_US(t)*(Energy_Price_US(t)*lambda_2/(Coal_Price_US(t)+Tax_Coal_US(t)))^(1/(1-rho));
                Green_Use_US(t)        =   Energy_Services_US(t)*(Energy_Price_US(t)*lambda_3/(Green_Price_US(t)+Tax_Green_US(t)))^(1/(1-rho));
                Oil_comp_Use_US(t)     =   Energy_Services_US(t)*(Energy_Price_US(t)*lambda_1/(Oil_comp_Price_US(t)))^(1/(1-rho));
                
                % % %                   Oil_Use_US(t)          =   Energy_Services_US(t)*(Energy_Price_US(t)*lambda_1/(Oil_Price(t)+Tax_Oil_US(t)))^(1/(1-rho));
                Oil_Use_US(t)          =   Oil_comp_Use_US(t)*(2^(rho_h/(1-rho_h)))*((Oil_weight*Oil_comp_Price_US(t)/(Oil_Price(t)+Tax_Oil_US(t)))^(1/(1-rho_h)));
                
                Oil_subst_Use_US(t)    =   Oil_comp_Use_US(t)*(2^(rho_h/(1-rho_h)))*(((1-Oil_weight)*Oil_comp_Price_US(t)/(Oil_subst_Price_US(t)+Tax_Oil_subst_US(t)))^(1/(1-rho_h)));
                
                Gross_Output_US(t)           =   Productivity_US(t)*(1-Damage_US(t))*(Capital_US(t)^alpha)*(Energy_Services_US(t)^nu);
                GDP_US(t)                    =   Gross_Output_US(t)-Oil_Price(t)*Oil_Use_US(t);
                Net_Output_Inc_tax_US(t)     =   (1-nu)*Gross_Output_US(t)+Tax_Oil_US(t)*Oil_Use_US(t)+Tax_Coal_US(t)*Coal_Use_US(t)+Tax_Green_US(t)*Green_Use_US(t) + Tax_Oil_subst_US(t)*Oil_subst_Use_US(t);
                Capital_US(t+1)              =   saving_rate*Net_Output_Inc_tax_US(t);
                MPK_US(t)                    =   alpha*Gross_Output_US(t)/Capital_US(t);
                Consuption_Yearly_US(t)      =   Net_Output_Inc_tax_US(t)*(1-alpha*beta)/10;
                
                % % % ---------------------------- CHINA ----------------------------------
                % % % ---------------------------- CHINA ----------------------------------
                % % % ---------------------------- CHINA ----------------------------------
                Damage_CH(t)           =   1 - exp(-gamma_CH*(S(t)-S_preind));
                Tax_Oil_CH(t)          =   Tax_carbon*Tax_rate_Oil_CH*(Growth_tax_rate^(t-1));
                Coal_Price_CH(t+1)     =   Coal_Price_CH(t);
                Tax_Coal_CH(t)         =   Tax_carbon*Tax_rate_Coal_CH*(Growth_tax_rate^(t-1)) - s_china;
                Green_Price_CH(t+1)    =   Green_Price_CH(t);
                Tax_Green_CH(t)        =   0;                
                
                Energy_Price_CH(t)     =   ((Oil_Price(t)+Tax_Oil_CH(t))^(rho/(rho-1))*lambda_1^(1/(1-rho)) +(Coal_Price_CH(t)+Tax_Coal_CH(t))^(rho/(rho-1))*lambda_2^(1/(1-rho))+...
                    (Green_Price_CH(t)+Tax_Green_CH(t))^(rho/(rho-1))*lambda_3^(1/(1-rho)))^((rho-1)/rho);
                
                Energy_Services_CH(t)  =   (nu*Productivity_CH(t)*(1-Damage_CH(t))*Capital_CH(t)^alpha/Energy_Price_CH(t))^(1/(1-nu));
                
                Coal_Use_CH(t)         =   Energy_Services_CH(t)*(Energy_Price_CH(t)*lambda_2/(Coal_Price_CH(t)+Tax_Coal_CH(t)))^(1/(1-rho));
                Green_Use_CH(t)        =   Energy_Services_CH(t)*(Energy_Price_CH(t)*lambda_3/(Green_Price_CH(t)+Tax_Green_CH(t)))^(1/(1-rho));
                
                Oil_Use_CH(t)          =   Energy_Services_CH(t)*(Energy_Price_CH(t)*lambda_1/(Oil_Price(t)+Tax_Oil_CH(t)))^(1/(1-rho));
                
                Gross_Output_CH(t)           =   Productivity_CH(t)*(1-Damage_CH(t))*(Capital_CH(t)^alpha)*(Energy_Services_CH(t)^nu);
                GDP_CH(t)                    =   Gross_Output_CH(t)-Oil_Price(t)*Oil_Use_CH(t);
                Net_Output_Inc_tax_CH(t)     =   (1-nu)*Gross_Output_CH(t)+Tax_Oil_CH(t)*Oil_Use_CH(t)+Tax_Coal_CH(t)*Coal_Use_CH(t)+Tax_Green_CH(t)*Green_Use_CH(t);
                Capital_CH(t+1)              =   saving_rate*Net_Output_Inc_tax_CH(t);
                MPK_CH(t)                    =   alpha*Gross_Output_CH(t)/Capital_CH(t);
                Consuption_Yearly_CH(t)      =   Net_Output_Inc_tax_CH(t)*(1-alpha*beta)/10;
                
                % % % --------------------------- AFRICA ----------------------------------
                % % % --------------------------- AFRICA ----------------------------------
                % % % --------------------------- AFRICA ----------------------------------
                Damage_AF(t)         =   1 - exp(-gamma_AF*(S(t)-S_preind));
                Tax_Oil_AF(t)        =   Tax_carbon*Tax_rate_Oil_DEV*(Growth_tax_rate^(t-1));
                Coal_Price_AF(t+1)   =   Coal_Price_AF(t);
                Tax_Coal_AF(t)       =   Tax_carbon*Tax_rate_Coal_DEV*(Growth_tax_rate^(t-1));
                Green_Price_AF(t+1)  =   Green_Price_AF(t);
                Tax_Green_AF(t)      =   0;
                Energy_Price_AF(t)   =   ((Oil_Price(t)+Tax_Oil_AF(t))^(rho/(rho-1))*lambda_1^(1/(1-rho)) +(Coal_Price_AF(t)+Tax_Coal_AF(t))^(rho/(rho-1))*lambda_2^(1/(1-rho))+...
                    (Green_Price_AF(t)+Tax_Green_AF(t))^(rho/(rho-1))*lambda_3^(1/(1-rho)))^((rho-1)/rho);
                
                Energy_Services_AF(t)  =   (nu*Productivity_AF(t)*(1-Damage_AF(t))*Capital_AF(t)^alpha/Energy_Price_AF(t))^(1/(1-nu));
                
                Oil_Use_AF(t)          =   Energy_Services_AF(t)*(Energy_Price_AF(t)*lambda_1/(Oil_Price(t)+Tax_Oil_AF(t)))^(1/(1-rho));
                Coal_Use_AF(t)         =   Energy_Services_AF(t)*(Energy_Price_AF(t)*lambda_2/(Coal_Price_AF(t)+Tax_Coal_AF(t)))^(1/(1-rho));
                Green_Use_AF(t)        =   Energy_Services_AF(t)*(Energy_Price_AF(t)*lambda_3/(Green_Price_AF(t)+Tax_Green_AF(t)))^(1/(1-rho));
                
                Gross_Output_AF(t)           =   Productivity_AF(t)*(1-Damage_AF(t))*(Capital_AF(t)^alpha)*(Energy_Services_AF(t)^nu);
                GDP_AF(t)                    =   Gross_Output_AF(t)-Oil_Price(t)*Oil_Use_AF(t);
                Net_Output_Inc_tax_AF(t)     =   (1-nu)*Gross_Output_AF(t)+Tax_Oil_AF(t)*Oil_Use_AF(t)+Tax_Coal_AF(t)*Coal_Use_AF(t)+Tax_Green_AF(t)*Green_Use_AF(t);
                Capital_AF(t+1)              =   saving_rate*Net_Output_Inc_tax_AF(t);
                MPK_AF(t)                    =   alpha*Gross_Output_AF(t)/Capital_AF(t);
                Consuption_Yearly_AF(t)      =   Net_Output_Inc_tax_AF(t)*(1-alpha*beta)/10;
                
                % % % ---------------------------- INDIA ----------------------------------
                % % % ---------------------------- INDIA ----------------------------------
                % % % ---------------------------- INDIA ----------------------------------
                Damage_IND(t)           =   1 - exp(-gamma_IND*(S(t)-S_preind));
                Tax_Oil_IND(t)          =   Tax_carbon*Tax_rate_Oil_DEV*(Growth_tax_rate^(t-1));
                Coal_Price_IND(t+1)     =   Coal_Price_IND(t);
                Tax_Coal_IND(t)         =   Tax_carbon*Tax_rate_Coal_DEV*(Growth_tax_rate^(t-1));
                Green_Price_IND(t+1)    =   Green_Price_IND(t);
                Tax_Green_IND(t)        =   0;
                Energy_Price_IND(t)     =   ((Oil_Price(t)+Tax_Oil_IND(t))^(rho/(rho-1))*lambda_1^(1/(1-rho)) +(Coal_Price_IND(t)+Tax_Coal_IND(t))^(rho/(rho-1))*lambda_2^(1/(1-rho))+...
                    (Green_Price_IND(t)+Tax_Green_IND(t))^(rho/(rho-1))*lambda_3^(1/(1-rho)))^((rho-1)/rho);
                
                Energy_Services_IND(t)  =   (nu*Productivity_IND(t)*(1-Damage_IND(t))*Capital_IND(t)^alpha/Energy_Price_IND(t))^(1/(1-nu));
                
                Oil_Use_IND(t)          =   Energy_Services_IND(t)*(Energy_Price_IND(t)*lambda_1/(Oil_Price(t)+Tax_Oil_IND(t)))^(1/(1-rho));
                Coal_Use_IND(t)         =   Energy_Services_IND(t)*(Energy_Price_IND(t)*lambda_2/(Coal_Price_IND(t)+Tax_Coal_IND(t)))^(1/(1-rho));
                Green_Use_IND(t)        =   Energy_Services_IND(t)*(Energy_Price_IND(t)*lambda_3/(Green_Price_IND(t)+Tax_Green_IND(t)))^(1/(1-rho));
                
                Gross_Output_IND(t)           =   Productivity_IND(t)*(1-Damage_IND(t))*(Capital_IND(t)^alpha)*(Energy_Services_IND(t)^nu);
                GDP_IND(t)                    =   Gross_Output_IND(t)-Oil_Price(t)*Oil_Use_IND(t);
                Net_Output_Inc_tax_IND(t)     =   (1-nu)*Gross_Output_IND(t)+Tax_Oil_IND(t)*Oil_Use_IND(t)+Tax_Coal_IND(t)*Coal_Use_IND(t)+Tax_Green_IND(t)*Green_Use_IND(t);
                Capital_IND(t+1)              =   saving_rate*Net_Output_Inc_tax_IND(t);
                MPK_IND(t)                    =   alpha*Gross_Output_IND(t)/Capital_IND(t);
                Consuption_Yearly_IND(t)      =   Net_Output_Inc_tax_IND(t)*(1-alpha*beta)/10;
                
                % % % ------------------------ SOUTH AMERICA ------------------------------
                % % % ------------------------ SOUTH AMERICA ------------------------------
                % % % ------------------------ SOUTH AMERICA ------------------------------
                Damage_SA(t)           =   1 - exp(-gamma_SA*(S(t)-S_preind));
                Tax_Oil_SA(t)          =   Tax_carbon*Tax_rate_Oil_SA*(Growth_tax_rate^(t-1));
                Coal_Price_SA(t+1)     =   Coal_Price_SA(t);
                Tax_Coal_SA(t)         =   Tax_carbon*Tax_rate_Coal_SA*(Growth_tax_rate^(t-1));
                Green_Price_SA(t+1)    =   Green_Price_SA(t);
                Tax_Green_SA(t)        =   0;
                Energy_Price_SA(t)     =   ((Oil_Price(t)+Tax_Oil_SA(t))^(rho/(rho-1))*lambda_1^(1/(1-rho)) +(Coal_Price_SA(t)+Tax_Coal_SA(t))^(rho/(rho-1))*lambda_2^(1/(1-rho))+...
                    (Green_Price_SA(t)+Tax_Green_SA(t))^(rho/(rho-1))*lambda_3^(1/(1-rho)))^((rho-1)/rho);
                
                Energy_Services_SA(t)  =   (nu*Productivity_SA(t)*(1-Damage_SA(t))*Capital_SA(t)^alpha/Energy_Price_SA(t))^(1/(1-nu));
                
                Oil_Use_SA(t)          =   Energy_Services_SA(t)*(Energy_Price_SA(t)*lambda_1/(Oil_Price(t)+Tax_Oil_SA(t)))^(1/(1-rho));
                Coal_Use_SA(t)         =   Energy_Services_SA(t)*(Energy_Price_SA(t)*lambda_2/(Coal_Price_SA(t)+Tax_Coal_SA(t)))^(1/(1-rho));
                Green_Use_SA(t)        =   Energy_Services_SA(t)*(Energy_Price_SA(t)*lambda_3/(Green_Price_SA(t)+Tax_Green_SA(t)))^(1/(1-rho));
                
                Gross_Output_SA(t)           =   Productivity_SA(t)*(1-Damage_SA(t))*(Capital_SA(t)^alpha)*(Energy_Services_SA(t)^nu);
                GDP_SA(t)                    =   Gross_Output_SA(t)- Oil_Price(t)*Oil_Use_SA(t);
                Net_Output_Inc_tax_SA(t)     =   (1-nu)*Gross_Output_SA(t)+Tax_Oil_SA(t)*Oil_Use_SA(t)+Tax_Coal_SA(t)*Coal_Use_SA(t)+Tax_Green_SA(t)*Green_Use_SA(t);
                Capital_SA(t+1)              =   saving_rate*Net_Output_Inc_tax_SA(t);
                MPK_SA(t)                    =   alpha*Gross_Output_SA(t)/Capital_SA(t);
                Consuption_Yearly_SA(t)      =   Net_Output_Inc_tax_SA(t)*(1-alpha*beta)/10;
                
                % % % ---------------------------- OCEANIA -------------------------------
                % % % ---------------------------- OCEANIA -------------------------------
                % % % ---------------------------- OCEANIA -------------------------------
                Damage_OC(t)           =   1 - exp(-gamma_OC*(S(t)-S_preind));
                Tax_Oil_OC(t)          =   Tax_carbon*Tax_rate_Oil_OC*(Growth_tax_rate^(t-1));
                Coal_Price_OC(t+1)     =   Coal_Price_OC(t);
                Tax_Coal_OC(t)         =   Tax_carbon*Tax_rate_Coal_OC*(Growth_tax_rate^(t-1));
                Green_Price_OC(t+1)    =   Green_Price_OC(t);
                Tax_Green_OC(t)        =   0;
                Energy_Price_OC(t)     =   ((Oil_Price(t)+Tax_Oil_OC(t))^(rho/(rho-1))*lambda_1^(1/(1-rho)) +(Coal_Price_OC(t)+Tax_Coal_OC(t))^(rho/(rho-1))*lambda_2^(1/(1-rho))+...
                    (Green_Price_OC(t)+Tax_Green_OC(t))^(rho/(rho-1))*lambda_3^(1/(1-rho)))^((rho-1)/rho);
                
                Energy_Services_OC(t)  =   (nu*Productivity_OC(t)*(1-Damage_OC(t))*Capital_OC(t)^alpha/Energy_Price_OC(t))^(1/(1-nu));
                
                Oil_Use_OC(t)          =   Energy_Services_OC(t)*(Energy_Price_OC(t)*lambda_1/(Oil_Price(t)+Tax_Oil_OC(t)))^(1/(1-rho));
                Coal_Use_OC(t)         =   Energy_Services_OC(t)*(Energy_Price_OC(t)*lambda_2/(Coal_Price_OC(t)+Tax_Coal_OC(t)))^(1/(1-rho));
                Green_Use_OC(t)        =   Energy_Services_OC(t)*(Energy_Price_OC(t)*lambda_3/(Green_Price_OC(t)+Tax_Green_OC(t)))^(1/(1-rho));
                
                Gross_Output_OC(t)           =   Productivity_OC(t)*(1-Damage_OC(t))*(Capital_OC(t)^alpha)*(Energy_Services_OC(t)^nu);
                GDP_OC(t)                    =   Gross_Output_OC(t)-Oil_Price(t)*Oil_Use_OC(t);
                Net_Output_Inc_tax_OC(t)     =   (1-nu)*Gross_Output_OC(t)+Tax_Oil_OC(t)*Oil_Use_OC(t)+Tax_Coal_OC(t)*Coal_Use_OC(t)+Tax_Green_OC(t)*Green_Use_OC(t);
                Capital_OC(t+1)              =   saving_rate*Net_Output_Inc_tax_OC(t);
                MPK_OC(t)                    =   alpha*Gross_Output_OC(t)/Capital_OC(t);
                Consuption_Yearly_OC(t)      =   Net_Output_Inc_tax_OC(t)*(1-alpha*beta)/10;
                
                % % % ----------------------- OIL PRODUCERS -------------------------------
                % % % ----------------------- OIL PRODUCERS -------------------------------
                % % % ----------------------- OIL PRODUCERS -------------------------------
                Cons_Oil_Producers(t)   =   Oil_Price(t)*Oil_Supply(t);
                
                Emissions_Oil_Count(t)   =   Supply_emiss*Oil_Supply(t);
                
                Oil_Use_Agg(t)   =   Oil_Use_EU(t) + Oil_Use_US(t) + Oil_Use_CH(t) + Oil_Use_AF(t) + Oil_Use_IND(t)+ Oil_Use_SA(t)+ Oil_Use_OC(t);
                
                % % % ----------------------- UPDATE THE OIL PRICE ------------------------
                % % % ----------------------- UPDATE THE OIL PRICE ------------------------
                % % % ----------------------- UPDATE THE OIL PRICE ------------------------
                if Oil_Use_Agg(t)>Oil_Supply(t)
                    Oil_Price_min   =   Oil_Price(t);
                else
                    Oil_Price_max   =   Oil_Price(t);
                end
                
                Oil_Price(t)   =   (Oil_Price_min + Oil_Price_max)/2;
                
                diff_oil_p   =   abs(Oil_Price(t)-Oil_Price_old);
                
                Oil_Price_old   =   Oil_Price(t);
            end
            
            if (Oil_Price(t)==Oil_Price_min_1(t)) || (Oil_Price(t)==Oil_Price_max_1(t))
                disp('WARNING!!! BOUNDARY HIT!!!')
            end
            
            % % % ---------------------- AGGREGATE QUANTITIES -------------------------
            % % % ---------------------- AGGREGATE QUANTITIES -------------------------
            % % % ---------------------- AGGREGATE QUANTITIES -------------------------
            
            Coal_Use_Agg(t)    =   Coal_Use_EU(t) + Coal_Use_US(t) + Coal_Use_CH(t) + Coal_Use_AF(t) + Coal_Use_IND(t) + Coal_Use_SA(t) + Coal_Use_OC(t);
            Green_Use_Agg(t)   =   Green_Use_EU(t) + Green_Use_US(t) + Green_Use_CH(t) + Green_Use_AF(t) + Green_Use_IND(t) + Green_Use_SA(t) + Green_Use_OC(t);
            Fracking_Agg(t)    =   Oil_subst_Use_US(t);
            GROSS_OUT_Yearly_Agg(t)  =   (Gross_Output_EU(t) + Gross_Output_US(t) + Gross_Output_CH(t)+ Gross_Output_AF(t) + Gross_Output_IND(t) + Gross_Output_SA(t)+ Gross_Output_OC(t))/10;
            GDP_Yearly_Agg(t)        =   (GDP_EU(t) + GDP_US(t) + GDP_CH(t) +GDP_AF(t) + GDP_IND(t) + GDP_SA(t) + GDP_OC(t))/10;
            
            Emissions_Agg(t)      =   Oil_Supply(t) + Coal_Use_Agg(t) + Fracking_Agg(t)  + Emissions_Oil_Count(t);
            
            % % % ------------------ CO2, TEMPERATURE AND FORCING ---------------------
            Global_Damage(t)   =   1-exp(-gamma_global*(S(t)-S_preind));
            
            Oil_Price_Barrel   =   Oil_Price*(1000/7.33)*Carbon_content_oil;
            
            if t==1
                S2(t)      =   (699-S_preind)*(1-psi)+psi0*(1-psiL)*(Emissions_Agg(1));
                S1_S_Bar(t)   =   103+psiL*(Emissions_Agg(t));
            else
                S2(t)      =   (S2(t-1))*(1-psi)+psi0*(1-psiL)*(Emissions_Agg(t));
                S1_S_Bar(t)   =   S1_S_Bar(t-1)+psiL*(Emissions_Agg(t));
            end
            
            S(t+1)         =   S2(t)+S1_S_Bar(t)+S_preind;
            Forcing(t+1)   =   eta*log(S(t+1)/S_preind)/log(2);
            Temp(t+1)      =   Temp(t)+Sigma1*(Forcing(t+1)-(eta/lambda)*Temp(t)-Sigma2*(Temp(t)-Temp_L(t)));
            Temp_L(t+1)    =   Temp_L(t)+Sigma3*(Temp(t)-Temp_L(t));
            
            % % % ----------------- NEW BOUNDARIES FOR THE OIL PRICE  -----------------
            Oil_Price_min   =   Oil_Price(t)/3;
            Oil_Price_max   =   Oil_Price(t)*3;
            
            Oil_Price_min_1(t+1)   =   Oil_Price_min;
            Oil_Price_max_1(t+1)   =   Oil_Price_max;
            
            Oil_Price(t+1)   =   (Oil_Price_min + Oil_Price_max)/2;
            
        end
        
        
        % % % ------------------- IND=1: LOW GAMMA, CORRECT TAX -------------------
        % % % ------------------- IND=2: LOW GAMMA, INCORRECT TAX -----------------
        % % % ------------------- IND=3: HIGH GAMMA, INCORRECT TAX ------------------
        % % % ------------------- IND=4: HIGH GAMMA, CORRECT TAX ----------------
                
        
        % % %           ------------ SAVE ENERGY USE AND CONSUMPTION
        
        CONS_EU(IND,:)   =   Consuption_Yearly_EU';
        CONS_US(IND,:)   =   Consuption_Yearly_US';
        CONS_CH(IND,:)   =   Consuption_Yearly_CH';
        CONS_AF(IND,:)   =   Consuption_Yearly_AF';
        CONS_IND(IND,:)  =   Consuption_Yearly_IND';
        CONS_SA(IND,:)   =   Consuption_Yearly_SA';
        CONS_OC(IND,:)   =   Consuption_Yearly_OC';
        
        
        CONS_OP(IND,:)   =   Cons_Oil_Producers'./10;
        
        
        OIL_EU(IND,:)   =   Oil_Use_EU';
        OIL_US(IND,:)   =   Oil_Use_US';
        OIL_CH(IND,:)   =   Oil_Use_CH';
        OIL_AF(IND,:)   =   Oil_Use_AF';
        OIL_IND(IND,:)  =   Oil_Use_IND';
        OIL_SA(IND,:)   =   Oil_Use_SA';
        OIL_OC(IND,:)   =   Oil_Use_OC';
        
        COAL_EU(IND,:)   =   Coal_Use_EU';
        COAL_US(IND,:)   =   Coal_Use_US';
        COAL_CH(IND,:)   =   Coal_Use_CH';
        COAL_AF(IND,:)   =   Coal_Use_AF';
        COAL_IND(IND,:)  =   Coal_Use_IND';
        COAL_SA(IND,:)   =   Coal_Use_SA';
        COAL_OC(IND,:)   =   Coal_Use_OC';
        
        GREEN_EU(IND,:)   =   Green_Use_EU';
        GREEN_US(IND,:)   =   Green_Use_US';
        GREEN_CH(IND,:)   =   Green_Use_CH';
        GREEN_AF(IND,:)   =   Green_Use_AF';
        GREEN_IND(IND,:)  =   Green_Use_IND';
        GREEN_SA(IND,:)   =   Green_Use_SA';
        GREEN_OC(IND,:)   =   Green_Use_OC';
        
        ENERGY_COMP_EU(IND,:)   =   Energy_Services_EU';
        ENERGY_COMP_US(IND,:)   =   Energy_Services_US';
        ENERGY_COMP_CH(IND,:)   =   Energy_Services_CH';
        ENERGY_COMP_AF(IND,:)   =   Energy_Services_AF';
        ENERGY_COMP_IND(IND,:)  =   Energy_Services_IND';
        ENERGY_COMP_SA(IND,:)   =   Energy_Services_SA';
        ENERGY_COMP_OC(IND,:)   =   Energy_Services_OC';
        
    end
end


% % % ------------------- FOR THE PLOTS: Lw - Linewidth -------------------
% % % ------------------- FOR THE PLOTS: Lw - Linewidth -------------------
% % % ------------------- FOR THE PLOTS: Lw - Linewidth -------------------
Lw_1=4;
Lw_2=1;

elast_dum   =  elast;


% % % --------------------- TYPE 1 AND TYPE 2 ERRORS-----------------------
% % % --------------------- TYPE 1 AND TYPE 2 ERRORS-----------------------
% % % --------------------- TYPE 1 AND TYPE 2 ERRORS-----------------------

% % % ---------------------- SAVE BENNCHMARK VALUES------------------------

if elast==BM_elast
    EU_high_tax_BM   =  (1-CONS_EU(2,1:end)./CONS_EU(1,1:end))*100;
    EU_low_tax_BM   =  (1-CONS_EU(3,1:end)./CONS_EU(4,1:end))*100;
    
    US_high_tax_BM   =  (1-CONS_US(2,1:end)./CONS_US(1,1:end))*100;
    US_low_tax_BM   =  (1-CONS_US(3,1:end)./CONS_US(4,1:end))*100;
    
    CH_high_tax_BM   =  (1-CONS_CH(2,1:end)./CONS_CH(1,1:end))*100;
    CH_low_tax_BM   =  (1-CONS_CH(3,1:end)./CONS_CH(4,1:end))*100;
    
    AF_high_tax_BM   =  (1-CONS_AF(2,1:end)./CONS_AF(1,1:end))*100;
    AF_low_tax_BM   =  (1-CONS_AF(3,1:end)./CONS_AF(4,1:end))*100;
    
    IND_high_tax_BM   =  (1-CONS_IND(2,1:end)./CONS_IND(1,1:end))*100;
    IND_low_tax_BM   =  (1-CONS_IND(3,1:end)./CONS_IND(4,1:end))*100;
    
    SA_high_tax_BM   =  (1-CONS_SA(2,1:end)./CONS_SA(1,1:end))*100;
    SA_low_tax_BM   =  (1-CONS_SA(3,1:end)./CONS_SA(4,1:end))*100;
    
    OC_high_tax_BM   =  (1-CONS_OC(2,1:end)./CONS_OC(1,1:end))*100;
    OC_low_tax_BM   =  (1-CONS_OC(3,1:end)./CONS_OC(4,1:end))*100;

    OP_high_tax_BM   =  (1-CONS_OP(2,1:end)./CONS_OP(1,1:end))*100;
    OP_low_tax_BM   =  (1-CONS_OP(3,1:end)./CONS_OP(4,1:end))*100;

    
    % % % --------------------------- FUELS -----------------------------------
    
    % LOW CLIMATE, LOW ECONOMIC; LOW CLIMATE, HIGH ECONOMIC;
    % HIGH CLIMATE, LOW ECONOMIC; HIGH CLIMATE, HIGH ECONOMIC;
    
    EU_coal_Underestimate_BM    =  COAL_EU(3,:);
    US_coal_Underestimate_BM    =  COAL_US(3,:);
    CH_coal_Underestimate_BM    =  COAL_CH(3,:);
    AF_coal_Underestimate_BM    =  COAL_AF(3,:);
    IND_coal_Underestimate_BM   =  COAL_IND(3,:);
    SA_coal_Underestimate_BM    =  COAL_SA(3,:);
    OC_coal_Underestimate_BM    =  COAL_OC(3,:);
    
    EU_coal_Overestimate_BM    =  COAL_EU(2,:);
    US_coal_Overestimate_BM    =  COAL_US(2,:);
    CH_coal_Overestimate_BM    =  COAL_CH(2,:);
    AF_coal_Overestimate_BM    =  COAL_AF(2,:);
    IND_coal_Overestimate_BM   =  COAL_IND(2,:);
    SA_coal_Overestimate_BM    =  COAL_SA(2,:);
    OC_coal_Overestimate_BM    =  COAL_OC(2,:);
    
    EU_green_Underestimate_BM    =  GREEN_EU(3,:);
    US_green_Underestimate_BM    =  GREEN_US(3,:);
    CH_green_Underestimate_BM    =  GREEN_CH(3,:);
    AF_green_Underestimate_BM    =  GREEN_AF(3,:);
    IND_green_Underestimate_BM   =  GREEN_IND(3,:);
    SA_green_Underestimate_BM    =  GREEN_SA(3,:);
    OC_green_Underestimate_BM    =  GREEN_OC(3,:);
    
    EU_green_Overestimate_BM    =  GREEN_EU(2,:);
    US_green_Overestimate_BM    =  GREEN_US(2,:);
    CH_green_Overestimate_BM    =  GREEN_CH(2,:);
    AF_green_Overestimate_BM    =  GREEN_AF(2,:);
    IND_green_Overestimate_BM   =  GREEN_IND(2,:);
    SA_green_Overestimate_BM    =  GREEN_SA(2,:);
    OC_green_Overestimate_BM    =  GREEN_OC(2,:);
    
    
    Income_weight   =   GDP_Yearly_Agg(1:end) +  (Cons_Oil_Producers(1:end)/10);
    
    
    % % % ----------------- INCOME WEIGHTS -------------------
    I_EU    =   (GDP_EU(1:end)./10)./Income_weight(1:end);
    I_US    =   (GDP_US(1:end)./10)./Income_weight(1:end);
    I_CH    =   (GDP_CH(1:end)./10)./Income_weight(1:end);
    I_AF    =   (GDP_AF(1:end)./10)./Income_weight(1:end);
    I_SA    =   (GDP_SA(1:end)./10)./Income_weight(1:end);
    I_IND   =   (GDP_IND(1:end)./10)./Income_weight(1:end);
    I_OC    =   (GDP_OC(1:end)./10)./Income_weight(1:end);
    I_OP    =   (Cons_Oil_Producers(1:end)./10)./Income_weight(1:end);
    
    % % % ------------ INCOME WEIGHTED COSTS OF ERROR 1 -------------------
    Cost_low_tax_correct_BM   =   ...
        (1-(CONS_EU(3,1:end)./CONS_EU(4,1:end)))'.*I_EU + ...
        (1-(CONS_US(3,1:end)./CONS_US(4,1:end)))'.*I_US + ...
        (1-(CONS_CH(3,1:end)./CONS_CH(4,1:end)))'.*I_CH + ...
        (1-(CONS_IND(3,1:end)./CONS_IND(4,1:end)))'.*I_IND + ...
        (1-(CONS_AF(3,1:end)./CONS_AF(4,1:end)))'.*I_AF + ...
        (1-(CONS_SA(3,1:end)./CONS_SA(4,1:end)))'.*I_SA + ...
        (1-(CONS_OC(3,1:end)./CONS_OC(4,1:end)))'.*I_OC + ...
        (1-(CONS_OP(3,1:end)./CONS_OP(4,1:end)))'.*I_OP;
    
    % % % ------------ INCOME WEIGHTED COSTS OF ERROR 2 -------------------
    Cost_high_tax_correct_BM   =   ...
        (1-(CONS_EU(2,1:end)./CONS_EU(1,1:end)))'.*I_EU + ...
        (1-(CONS_US(2,1:end)./CONS_US(1,1:end)))'.*I_US + ...
        (1-(CONS_CH(2,1:end)./CONS_CH(1,1:end)))'.*I_CH + ...
        (1-(CONS_IND(2,1:end)./CONS_IND(1,1:end)))'.*I_IND + ...
        (1-(CONS_AF(2,1:end)./CONS_AF(1,1:end)))'.*I_AF + ...
        (1-(CONS_SA(2,1:end)./CONS_SA(1,1:end)))'.*I_SA + ...
        (1-(CONS_OC(2,1:end)./CONS_OC(1,1:end)))'.*I_OC + ...
        (1-(CONS_OP(2,1:end)./CONS_OP(1,1:end)))'.*I_OC;
    
    save BM_elast ...
        AF_high_tax_BM AF_low_tax_BM ...
        Cost_low_tax_correct_BM Cost_high_tax_correct_BM ...
        EU_coal_Underestimate_BM US_coal_Underestimate_BM ...
        CH_coal_Underestimate_BM AF_coal_Underestimate_BM ...
        IND_coal_Underestimate_BM  SA_coal_Underestimate_BM ...
        OC_coal_Underestimate_BM ...
        EU_coal_Overestimate_BM US_coal_Overestimate_BM ...
        CH_coal_Overestimate_BM AF_coal_Overestimate_BM ...
        IND_coal_Overestimate_BM  SA_coal_Overestimate_BM ...
        OC_coal_Overestimate_BM ...
        EU_green_Underestimate_BM US_green_Underestimate_BM ...
        CH_green_Underestimate_BM AF_green_Underestimate_BM ...
        IND_green_Underestimate_BM  SA_green_Underestimate_BM ...
        OC_green_Underestimate_BM ...
        EU_green_Overestimate_BM US_green_Overestimate_BM ...
        CH_green_Overestimate_BM AF_green_Overestimate_BM ...
        IND_green_Overestimate_BM  SA_green_Overestimate_BM ...
        OC_green_Overestimate_BM ...
        EU_high_tax_BM EU_low_tax_BM US_high_tax_BM US_low_tax_BM ...
        CH_high_tax_BM CH_low_tax_BM AF_high_tax_BM AF_low_tax_BM ...
        IND_high_tax_BM IND_low_tax_BM SA_high_tax_BM SA_low_tax_BM ...
        OC_high_tax_BM OC_low_tax_BM OP_high_tax_BM OP_low_tax_BM
        
end


% % % ------------------------- TYPE 1 AND 2 ERRORS -----------------------
% % % ------------------------- TYPE 1 AND 2 ERRORS -----------------------
% % % ------------------------- TYPE 1 AND 2 ERRORS -----------------------



load BM_elast

Income_weight   =   GDP_Yearly_Agg(1:end) +  (Cons_Oil_Producers(1:end)/10);
I_EU    =   (GDP_EU(1:end)./10)./Income_weight(1:end);
I_US    =   (GDP_US(1:end)./10)./Income_weight(1:end);
I_CH    =   (GDP_CH(1:end)./10)./Income_weight(1:end);
I_AF    =   (GDP_AF(1:end)./10)./Income_weight(1:end);
I_SA    =   (GDP_SA(1:end)./10)./Income_weight(1:end);
I_IND   =   (GDP_IND(1:end)./10)./Income_weight(1:end);
I_OC    =   (GDP_OC(1:end)./10)./Income_weight(1:end);
I_OP    =   (Cons_Oil_Producers(1:end)./10)./Income_weight(1:end);
    
% % % IND   =  1: LOW TAX WHEN LOW TAX IS CORRECT
% % % IND   =  2: HIGH TAX WHEN LOW TAX IS CORRECT
% % % IND   =  3: LOW TAX WHEN HIGH TAX IS CORRECT
% % % IND   =  4: HIGH TAX WHEN HIGH TAX IS CORRECT


Cost_low_tax_high_is_correct   =   ...
    (1-(CONS_EU(3,1:end)./CONS_EU(4,1:end)))'.*I_EU + ...
    (1-(CONS_US(3,1:end)./CONS_US(4,1:end)))'.*I_US + ...
    (1-(CONS_CH(3,1:end)./CONS_CH(4,1:end)))'.*I_CH + ...
    (1-(CONS_IND(3,1:end)./CONS_IND(4,1:end)))'.*I_IND + ...
    (1-(CONS_AF(3,1:end)./CONS_AF(4,1:end)))'.*I_AF + ...
    (1-(CONS_SA(3,1:end)./CONS_SA(4,1:end)))'.*I_SA + ...
    (1-(CONS_OC(3,1:end)./CONS_OC(4,1:end)))'.*I_OC + ...
    (1-(CONS_OP(3,1:end)./CONS_OP(4,1:end)))'.*I_OP;

Cost_high_tax_low_is_correct   =   ...
    (1-(CONS_EU(2,1:end)./CONS_EU(1,1:end)))'.*I_EU + ...
    (1-(CONS_US(2,1:end)./CONS_US(1,1:end)))'.*I_US + ...
    (1-(CONS_CH(2,1:end)./CONS_CH(1,1:end)))'.*I_CH + ...
    (1-(CONS_IND(2,1:end)./CONS_IND(1,1:end)))'.*I_IND + ...
    (1-(CONS_AF(2,1:end)./CONS_AF(1,1:end)))'.*I_AF + ...
    (1-(CONS_SA(2,1:end)./CONS_SA(1,1:end)))'.*I_SA + ...
    (1-(CONS_OC(2,1:end)./CONS_OC(1,1:end)))'.*I_OC + ...
    (1-(CONS_OP(2,1:end)./CONS_OP(1,1:end)))'.*I_OP;

% % % ---------------- FOR THE AXIS OF THE PLOTS ------------------
All_max    =  max(Cost_low_tax_high_is_correct(1:20)*100);
AF_max    =   max((1-CONS_AF(3,1:20)./CONS_AF(4,1:20))*10);

EU_max    =   max((1-CONS_EU(3,1:20)./CONS_EU(4,1:20))*10);
US_max    =   max((1-CONS_US(3,1:20)./CONS_US(4,1:20))*10);
CH_max    =   max((1-CONS_CH(3,1:20)./CONS_CH(4,1:20))*10);
SA_max    =   max((1-CONS_SA(3,1:20)./CONS_SA(4,1:20))*10);


All_max    =   ceil(All_max);
AF_max    =   10*ceil(AF_max);

% % % -------------------- PLOT REGIONAL EFFECTS --------------------------


figure
subplot(2,2,1)
plot(Year(1:end),(1-CONS_EU(3,1:end)./CONS_EU(4,1:end))*100,'k','linewidth',Lw_1)
hold on
plot(Year(1:end),(1-CONS_EU(2,1:end)./CONS_EU(1,1:end))*100,'--r','linewidth',Lw_1)


% % % - IF ELASTICITY DIFFERS FROM THE BENCHMARK, PLOT ALSO THE BENCHMARK -
if elast~=BM_elast
    hold on
    plot(Year(1:end),EU_low_tax_BM,'-.m','linewidth',Lw_1)
    hold on
    plot(Year(1:end),EU_high_tax_BM,'o-b','linewidth',Lw_2)
end

ylabel('{\itC} loss in %')
title('EU')
axis([2000 2200 -1 EU_max*10])
grid on

if elast~=BM_elast
    legend([strcat('Too low a tax , \epsilon=',(num2str(elast)));strcat('Too high a tax, \epsilon=',(num2str(elast))); ...
        strcat('Too low a tax , \epsilon=',(num2str(BM_elast))); strcat('Too high a tax, \epsilon=',(num2str(BM_elast)))],'FontSize',5, 'location', 'Northwest')
else
    legend([strcat('Too low a tax , \epsilon=',(num2str(elast)));strcat('Too high a tax, \epsilon=',(num2str(elast)))],'FontSize',6, 'location', 'Northwest')
end

subplot(2,2,2)

plot(Year(1:end),(1-CONS_US(3,1:end)./CONS_US(4,1:end))*100,'k','linewidth',Lw_1)
hold on
plot(Year(1:end),(1-CONS_US(2,1:end)./CONS_US(1,1:end))*100,'--r','linewidth',Lw_1)


% % % - IF ELASTICITY DIFFERS FROM THE BENCHMARK, PLOT ALSO THE BENCHMARK -
if elast~=BM_elast
    hold on
    plot(Year(1:end),US_low_tax_BM,'-.m','linewidth',Lw_1)
    hold on
    plot(Year(1:end),US_high_tax_BM,'o-b','linewidth',Lw_2)
end

ylabel('{\itC} loss in %')
title('U.S.')
axis([2000 2200 -1 US_max*10])
grid on

subplot(2,2,3)
% figure
plot(Year(1:end),(1-CONS_AF(3,1:end)./CONS_AF(4,1:end))*100,'k','linewidth',Lw_1)
hold on
plot(Year(1:end),(1-CONS_AF(2,1:end)./CONS_AF(1,1:end))*100,'--r','linewidth',Lw_1)


% % % - IF ELASTICITY DIFFERS FROM THE BENCHMARK, PLOT ALSO THE BENCHMARK -
if elast~=BM_elast
    hold on
    plot(Year(1:end),AF_low_tax_BM,'-.m','linewidth',Lw_1)
    hold on
    plot(Year(1:end),AF_high_tax_BM,'o-b','linewidth',Lw_2)
end

ylabel('{\itC} loss in %')
title('Africa')
axis([2000 2200 -1 AF_max])
grid on


subplot(2,2,4)
% figure
plot(Year(1:end),(1-CONS_IND(3,1:end)./CONS_IND(4,1:end))*100,'k','linewidth',Lw_1)
hold on
plot(Year(1:end),(1-CONS_IND(2,1:end)./CONS_IND(1,1:end))*100,'--r','linewidth',Lw_1)


% % % - IF ELASTICITY DIFFERS FROM THE BENCHMARK, PLOT ALSO THE BENCHMARK -
if elast~=BM_elast
    hold on
    plot(Year(1:end),IND_low_tax_BM,'-.m','linewidth',Lw_1)
    hold on
    plot(Year(1:end),IND_high_tax_BM,'o-b','linewidth',Lw_2)
end

ylabel('{\itC} loss in %')
title('India')
axis([2000 2200 -1 AF_max])
grid on


figure
subplot(2,2,1)
plot(Year(1:end),(1-CONS_CH(3,1:end)./CONS_CH(4,1:end))*100,'k','linewidth',Lw_1)
hold on
plot(Year(1:end),(1-CONS_CH(2,1:end)./CONS_CH(1,1:end))*100,'--r','linewidth',Lw_1)

% % % - IF ELASTICITY DIFFERS FROM THE BENCHMARK, PLOT ALSO THE BENCHMARK -
if elast~=BM_elast
    hold on
    plot(Year(1:end),CH_low_tax_BM,'-.m','linewidth',Lw_1)
    hold on
    plot(Year(1:end),CH_high_tax_BM,'o-b','linewidth',Lw_2)
end

if elast~=BM_elast
    legend([strcat('Too low a tax , \epsilon=',(num2str(elast)));strcat('Too high a tax, \epsilon=',(num2str(elast))); ...
        strcat('Too low a tax , \epsilon=',(num2str(BM_elast))); strcat('Too high a tax, \epsilon=',(num2str(BM_elast)))],'FontSize',5, 'location', 'Northwest')
else
    legend([strcat('Too low a tax , \epsilon=',(num2str(elast)));strcat('Too high a tax, \epsilon=',(num2str(elast)))],'FontSize',6, 'location', 'Northwest')
end

ylabel('{\itC} loss in %')
title('China')
axis([2000 2200 -1 All_max])
grid on


subplot(2,2,2)
% figure
plot(Year(1:end),(1-CONS_OC(3,1:end)./CONS_OC(4,1:end))*100,'k','linewidth',Lw_1)
hold on
plot(Year(1:end),(1-CONS_OC(2,1:end)./CONS_OC(1,1:end))*100,'--r','linewidth',Lw_1)

% % % - IF ELASTICITY DIFFERS FROM THE BENCHMARK, PLOT ALSO THE BENCHMARK -
if elast~=BM_elast
    hold on
    plot(Year(1:end),OC_low_tax_BM,'-.m','linewidth',Lw_1)
    hold on
    plot(Year(1:end),OC_high_tax_BM,'o-b','linewidth',Lw_2)
end

ylabel('{\itC} loss in %')
title('OC')
axis([2000 2200 -1 All_max])
grid on

subplot(2,2,3)
% figure
plot(Year(1:end),(1-CONS_SA(3,1:end)./CONS_SA(4,1:end))*100,'k','linewidth',Lw_1)
hold on
plot(Year(1:end),(1-CONS_SA(2,1:end)./CONS_SA(1,1:end))*100,'--r','linewidth',Lw_1)


% % % - IF ELASTICITY DIFFERS FROM THE BENCHMARK, PLOT ALSO THE BENCHMARK -
if elast~=BM_elast
    hold on
    plot(Year(1:end),SA_low_tax_BM,'-.m','linewidth',Lw_1)
    hold on
    plot(Year(1:end),SA_high_tax_BM,'o-b','linewidth',Lw_2)
end

ylabel('{\itC} loss in %')
title('SA')
axis([2000 2200 -1 All_max])
grid on

subplot(2,2,4)
% figure
plot(Year(1:end),Cost_low_tax_high_is_correct*100,'k','linewidth',Lw_1)
hold on;
plot(Year(1:end),Cost_high_tax_low_is_correct*100,'--r','linewidth',Lw_1)

% % % - IF ELASTICITY DIFFERS FROM THE BENCHMARK, PLOT ALSO THE BENCHMARK -
if elast~=BM_elast
    hold on
    plot(Year(1:end),Cost_low_tax_correct_BM*100,'-.m','linewidth',Lw_1)
    hold on
    plot(Year(1:end),Cost_high_tax_correct_BM*100,'o-b','linewidth',Lw_2)
end

ylabel('{\itC} loss in %')
title('Aggregate losses')
grid on
axis([2000 2200 -1 All_max])

