function [P,E,e1,e2,Y,D,C] = Eq_type_errors_sep_dam(A,lambda,rho,nu,p1,p2,gamma_tilde,tau)


% % % -- THIS FUNCTION GIVE THE EQUILIBRIUM QUANTITIES FOR A GIVEN tau --

P   =   (((lambda^(1/(1-rho)))*((p1 + tau)^(rho/(rho-1))))       +    (((1-lambda)^(1/(1-rho)))*(p2^(rho/(rho-1)))))^((rho-1)/rho);

E   =   ((nu*A)/P)^(1/(1-nu));

e1  =   E*(((P*lambda)/(p1 + tau))^(1/(1-rho)));

e2  =   E*(((P*(1-lambda))/p2)^(1/(1-rho)));

Y   =   A*(E^nu);

D   =   gamma_tilde*(e1^2);

C   =   Y - (p1*e1 + p2*e2) - D;


